routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('shop.layouts.master');
// });
Route::group(['prefix'=> '', 'namespace' => 'Shop' , 'as' => 'shop.'], function(){
     Route::get('/', 'ShopController@index')->name('index');
     Route::get('/the-loai/{slugParent}/{slug}', 'ShopController@categoryList')->name('categorylist');
     Route::get('/bai-viet/chi-tiet/{id}', 'ShopController@show')->name('detail');
     Route::get('/all-products', 'ShopController@allProducts')->name('allproducts');
     Route::get('/category-list/{name}_{id}', 'ShopController@categoryList')->name('categorylist');
     Route::post('/add-product-cart', 'ShopController@addProductToCart')->name('addproducttocart');
     Route::get('/gio-hang-cua-ban','ShopController@listCartProduct')->name('listcart');
     Route::post('/remove-item-cart','ShopController@removeItemCart')->name('removeitemcart');
     Route::post('/add-cart','ShopController@addCart')->name('addcart');
     Route::get('/ajax-show-cart','ShopController@ajaxShowCart')->name('ajaxshowcart');
     Route::post('/comment/add/{slug}_{id}', 'ShopController@addComment')->name('addcomment');
     Route::get('/about-us', 'ShopController@aboutUs')->name('about');
     Route::get('/contact-us', 'ShopController@contactUs')->name('contact');
     Route::post('/contact-us/add', 'ShopController@addContact')->name('addcontact');
});
Route::group(['prefix' => 'admin', 'namespace' => 'Admin','as'=>'admin.','middleware'=>['auth','checktype']], function () {
    Route::get('/', 'AdminController@index')->name('index');
     Route::group(['prefix' => 'category','as'=>'category.'], function () {
        Route::get('/', 'CategoryController@index')->name('list');
        Route::get('/add', 'CategoryController@create')->name('add');
        Route::post('/created', 'CategoryController@store')->name('created');
        Route::get('edit/{id}', 'CategoryController@edit')->name('edit');
        Route::post('/{id}', 'CategoryController@update')->name('update');
        Route::delete('/deletecate', 'CategoryController@destroy')->name('destroy');
    });
    Route::group(['prefix' => 'product','as'=>'product.'], function () {
        Route::get('/', 'ProductController@index')->name('list');
        Route::get('/add', 'ProductController@create')->name('add');
        Route::post('/created', 'ProductController@store')->name('created');
        Route::get('edit/{id}', 'ProductController@edit')->name('edit');
        Route::post('/{id}', 'ProductController@update')->name('update');
        Route::delete('/product/{id}', 'ProductController@destroy')->name('destroy');
        Route::post('/deleteimage', 'ProductController@deleteImage')->name('deleteimage');
        Route::post('/uploadimage/{type?}', 'ProductController@UploadMultiple')->name('uploadimage');
    });
       Route::group(['prefix' => 'order','as'=>'order.'], function () {
        Route::get('/', 'OrderController@index')->name('list');
        Route::get('/{status}', 'OrderController@indexStatus')->name('liststatus');
        Route::get('/ajax-show-orders','OrderController@ajaxShowOrders')->name('ajaxshoworders');
        Route::get('edit/{id}', 'OrderController@edit')->name('edit');
        Route::post('/{id}', 'OrderController@update')->name('update');
    });
});
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    protected $fillable=['name','price','content','active','category_id'];
  	public function category()
   {
   		return $this->belongsTo('App\Models\Category','category_id');
   }
     public function images()
    {
        return $this->morphMany(Image::class, 'imageable');
    }

    public function orderDetails()
    {
        return $this->hasMany(OrderDetail::class,'product_id');
    }
}

app/Http/Controllers/Admin/ProductController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\Product;
use Validator;
use App\Models\Image;
use File;
use App\Http\Requests\ProductRequest;
class ProductController extends Controller
{
    protected $categories;

    public function __construct()
    {
        $this->categories = Category::select()->get();
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
         $products = Product::select()->paginate(5);
        return view('admin.product.list',
            [
                'products' => $products
            ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
         $categories = Category::where('parent_id', '!=' , 0)->get();
        return view('admin.product.create',
            [
                'categories' => $categories
            ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
     public function store(ProductRequest $request)
    {
        $this->handleStore($request);
        return redirect()->route('admin.product.list');
    }

    public function handleStore($request)
    {

        $dataInput = array_merge($request->all(), [
            'content' => $request->content1,
        ]);
        $product = Product::create($dataInput);
        foreach ($request->file_uploads as $key => $val) {
            $dataImage['src'] = $val['src'];
            $dataImage['alt'] = str_slug($request->title)."-hinh-".$key;
            $dataImage['description'] = str_slug($request->title)."-hinh-".$key;
            $product->images()->create($dataImage);
        }
        return $product;
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
          $categories = $this->categories;
        $product = Product::findOrFail($id);
        return view('admin.product.update', ['product' => $product,
            'categories' => $categories]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
     public function update(ProductRequest $request, $id)
    {
        $model = Product::findOrFail($id);
        $this->handleUpdate($request, $model);
        return redirect()->route('admin.product.list');
    }

    public function handleUpdate($request, $model)
    {
        // dd($request->all());
        $dataInput = array_merge($request->all(), [
            'content' => $request->content1,
        ]);
        $product = $model->update($dataInput);
        $imagesModel = $model->images()->pluck('id')->toArray();
        $dataRequest = $request->file_uploads;
        foreach ($dataRequest as $key => $value) {
            if (isset($value['id'])) {
                $idProduct = $value['id'];
                $imageUpdate = $model->images()->find($idProduct);
                $oldImageSrc = $imageUpdate->src;
                $pos = array_search($value['id'], $imagesModel);
                unset($value['id']);
                if ($imageUpdate->update(['src' => $value['src']])) {
                    if ($oldImageSrc != $value['src']) {
                        File::delete($oldImageSrc);
                    }
                }
                unset($dataRequest[$key]);
                unset($imagesModel[$pos]);
            } else {
                $model->images()->create(['src' => $value['src']]);
            }
        }
        if (sizeof($imagesModel) > 0) {
            foreach ($imagesModel as $itemDelete) {
                $imageDelete = $model->images()->find($itemDelete);
                if ($imageDelete->delete()) {
                    $oldImageSrc = $imageDelete->src;
                    File::delete($imageDelete);
                }
            }
        }
        return $product;
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

        public function UploadMultiple(Request $request, $type = null)
    {
        $success = [];
        $errors = [];
        foreach ($request->file('files') as $key => $file) {
            $handle = $this->handleUploadMultiple($request, $key, $type);
            if ($handle['status'] == false) {
                $errors[] = $handle;
            }
            if ($handle['status'] == true) {
                $success[] = $handle;
            }
        }
        return [
            'success' => $success,
            'errors' => $errors,
        ];
    }

    public function handleUploadMultiple($request, $key, $type = null)
    {
        $validator = Validator::make($request->all(),
            [
                'files.' . $key => 'image',
            ],
            [
                'files.' . $key . '.image' => 'The file must be an image (jpeg, png, bmp, gif, or svg)',
            ]);
        if ($validator->fails()) {
            return [
                'status' => false,
                'file' => $request->file('files')[$key]->getClientOriginalName() ?? null,
                'errors' => $validator->errors()->getMessages()['files.' . $key],
            ];
        }
        $file = $request->file('files')[$key];
        if ($type) {
            $dir = 'uploads/' . $type . '/';
        } else {
            $dir = 'uploads/';
        }
        $date = date("dmY");
        $originName = $file->getClientOriginalName();
        $file_name = rand() . $date . '.' . $file->getClientOriginalExtension();
//        $file = request()->file('file');
//        $name = time() . $file->getClientOriginalName();
//        $filePath = 'products/' . $name;
//        Storage::disk('s3')->put($filePath, file_get_contents($file), 'public');
        if ($file->move($dir, $file_name)) {
            return ['status' => true, 'filename' => $dir . $file_name, 'filenameorigin' => $originName];
        }
        return ['status' => false, 'errors' => $originName];
    }
}

resources/views/admin/product/list.blade.php
@extends('admin.layouts.master')
@section('styles')
<style type="text/css" media="screen">
    .table-bordered tr td,th{
        vertical-align: middle;
        text-align: center;
    }
</style>
@endsection
@section('content')
    <!-- Page Heading -->
    <h1 class="h3 mb-2 text-gray-800">Products</h1>
    <p class="mb-4"></p>

    <!-- DataTales Example -->
    <div class="card shadow mb-4">
        <div class="card-header py-3">
            <h6 class="m-0 font-weight-bold text-primary">Products Table</h6>
        </div>
        <div class="card-header py-3">
            <div class="col-md-2">
                <a class="btn btn-success text-center" href="{{route('admin.product.add')}}"
                   style="width: 100%;margin-bottom: 10px;">
                    Add </a>
            </div>
        </div>
        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                    <thead>
                    <tr>
                        <th>ID</th>
                        <th>Name</th>
                        <th>Price</th>
                        <th>Image</th>
                        <th>Active</th>
                        <th>Category Name</th>
                        <th colspan="2">Control</th>
                    </tr>
                    </thead>
                    <tfoot>
                    <tr>
                         <th>ID</th>
                        <th>Name</th>
                        <th>Price</th>
                        <th>Image</th>
                        <th>Active</th>
                        <th>Category Name</th>
                        <th colspan="2">Control</th>
                    </tr>
                    </tfoot>
                    <tbody>
                    @foreach($products as $product)
                        <tr>
                            <td>{{$product->id}}</td>
                            <td>{{$product->name}}</td>
                            <td >
                                 <span class="price_product">{{ $product->price }}</span> VNĐ
                            </td>
                            <td align="center">
                                <img src="/{{$product->images[0]->src ??  ''}}" class="img-thumbnail rounded" style="max-width: 150px;" alt="">
                            </td>
                            <td>@if($product->active == 1 )
                                    Show
                                @else
                                    Hidden
                                @endif</td>
                            <td>
                                {{$product->category->name ?? "Error Or No Name"}}
                            </td>
                            <td>
                                <a class="btn btn-primary" href="{{route('admin.product.edit',['id'=>$product->id])}}">Update</a>
                            </td>
                            <td>
                                        <button type="button" class="btn btn-danger openModalDelete" data-toggle="modal" data-target="#exampleModalCenter" data-id="{{$product->id}}" data-action="{{route('admin.product.destroy',['id'=>$product->id])}}">
                                    Delete
                                </button>
                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
            <div class="col-12">
                {{ $products->links() }}
            </div>
        </div>
    </div>
    <!-- Modal -->
    <div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog"
         aria-labelledby="exampleModalCenterTitle" aria-hidden="true" data-keyboard="false" data-backdrop="static">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLongTitle"></h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    Nếu chắc chắn xóa vui lòng nhấn nút Delete <br>
                    <b style="color:#E02D1B;">Lưu ý khi xóa sản phẩm sẽ không thể phục hồi</b>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                       <form action="" method="POST" class="deleteForm">
                        @method('DELETE')
                        @csrf
                        <button class="btn btn-danger" id="idDelete" name="idDelete" value="">Delete</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection
@section('scripts')
 <script src="/js/fm_money/simple.money.format.js"></script>
    <script type="text/javascript" charset="utf-8" async defer>

      $( document ).ready(function() {
        $('.price_product').simpleMoneyFormat();
      // var money = $('.price_product').text();
      //       var money1 = $('.price_product').simpleMoneyFormat(money);
      //       console.log(money1);
      //       $('.price_product').html(money1);
        });
        
        $(document).on("click", ".openModalDelete", function () {
            var myBookId = $(this).data('id');
             var myUrl = $(this).data('action');
     $(".modal-content #idDelete").val( myBookId );
     $(".modal-footer .deleteForm").attr('action', myUrl);
     $(".modal-content #exampleModalLongTitle").html('Bạn Chắc Chắn muốn xóa sản phẩm số ' + myBookId + ' chứ ?');
     // As pointed out in comments, 
     // it is unnecessary to have to manually call the modal.
     // $('#addBookDialog').modal('show');
        });
    </script>

@endsection